SetGraphicsDriver GLMax2DDriver()
Global jscrw=DesktopWidth()-16
AppTitle$="OUYA Stats Display Doohickey"

Graphics jscrw,640,0
SetClsColor 240,240,255

Filename$=RequestFile$( "Open .csv File","csv",0)

Global data$[330000]
Global format$[33]
Global InkR[128]
Global InkG[128]
Global InkB[128]
Global InkID$[128]
Global IdentY[128]
Global None[128]
Global PerCount[128]
Global PerTitle$[128]
Global Accum[128]
Global Flagged[128]

Global WasY[128]
Global WasX[128]

CurrentDate()
TotalDownloads=0

Function SplitText$(in$,Split$,e,alsospace=0)

	'Splits text...
	Local out:String=""
	Local start:Int=1
	Local nomore:Int=0
	Local shift:Int
	Local size:Int

	in:String=Trim(in)
	e=e-1
	
	For shift=1 To e
		If Instr(in$,Split$,start)+1<=nstart Then nomore=1
		If Instr(in$,Split$,start)+1>nstart Then nstart=Instr(in$,Split$,start)+1
		If AlsoSpace=1 Then If Instr(in$," ",start)+1<nstart And Instr(in$," ",start)>0 Then nstart=Instr(in$," ",start)+1
		start=nstart
	Next
	size=(Instr(in$,Split$,start))-start
	If AlsoSpace=1 Then If (Instr(in$," ",start))-start<size And Instr(in$," ",start)>0 Then size=(Instr(in$," ",start))-start
	

	out$=Mid$(in$,start,size)
	If nomore=1 Then out$="-+-"
	Return out
End Function

quicky=ReadFile(Filename$)
in$=ReadLine(quicky)
count=1
title=1
date=1
top=0
bits=0
For m=1 To 32
	format[m]=splittext(in$,",",m)
	If Lower$(format[m])="count" Then count=m
	If Lower$(format[m])="title" Then title=m
	If Lower$(format[m])="date" Then date=m
	If format[m]<>"-+-" Then bits=m
Next
If bits>30 Then bits=30

datewas$="2999-12-31"
dats=0
x=0
inks=-1


MaxX=0
Repeat
	in$=ReadLine(quicky)
	If splittext(in$,",",date)<>datewas
		datewas=splittext(in$,",",date)
		x=x-64
	EndIf
	For m=1 To bits
		data[dats*32+m]=splittext(in$,",",m)
	Next
	If Int(data[dats*32+count])>Top Then top=Int(data[dats*32+count])
	TotalDownloads=TotalDownloads+Int(data[dats*32+count])

	ui=-1
	For i=0 To inks
		If InkID[i]=data[dats*32+title] Then ui=i
	Next
	
	If ui=-1
		inks=inks+1
		ui=inks
		inkR[ui]=Rand(0,18)*10
		inkG[ui]=Rand(0,18)*10
		inkB[ui]=Rand(0,18)*10
		PerTitle[ui]=data[dats*32+title]
		If ui=0 Then InkR[ui]=180;inkG[ui]=0;InkB[ui]=0
		If ui=1 Then InkR[ui]=0;inkG[ui]=180;InkB[ui]=0
		If ui=2 Then InkR[ui]=0;inkG[ui]=0;InkB[ui]=180
		If ui=3 Then InkR[ui]=180;inkG[ui]=0;InkB[ui]=180
		If ui=4 Then InkR[ui]=180;inkG[ui]=180;InkB[ui]=0
		If ui=5 Then InkR[ui]=0;inkG[ui]=90;InkB[ui]=180
		
		InkID[ui]=data[dats*32+title]
	EndIf
	
	PerCount[ui]=PerCount[ui]+Int(data[dats*32+count])
	data[dats*32+30]=ui
	data[dats*32+31]=x
	DebugLog x
	
	dats=dats+1
Until Eof(quicky)
CloseFile quicky
MaxX=Abs(x)

DebugLog "MaxX"+MaxX

scrollx=jscrw
scale#=535/Top

SetLineWidth(2)
SetBlend(ALPHABLEND)
leftmost=jscrw
accummost#=0

scaleX#=Float(jscrw-16)/Float(MaxX)

dategap=1

Repeat
Cls
steps=0
datewas$="2999-12-31"

If KeyHit(KEY_LEFT) Then scalex=scalex-0.05;If Scalex<0.2 Then scalex=0.2
If KeyHit(KEY_RIGHT) Then scalex=scalex+0.05;If Scalex>2 Then scalex=2

datespace=1000
dategap=1
If ScaleX<0.85 Then dategap=2
If ScaleX<0.6 Then dategap=4
If ScaleX<0.45 Then dategap=7


SetColor(0,0,0)
DrawText("OUYA Download Stats",4,4)
SetColor(100,100,100)
DrawText("DisplayStats app : http://bit.ly/OUYAStats",4,18)
SetColor(0,0,0)
For n=0 To 120
	Wasy[n]=0
	Flagged[n]=0
	Accum[n]=0
	None[n]=1
	IdentY[n]=640
Next
For m=0 To dats-1
	x=scrollx+Int(data[m*32+31])*scaleX
	i=Int(data[m*32+30])
	y=585-(Float(Int(data[m*32+count]))*scale)
	Accum[i]=Accum[i]+Int(data[m*32+count])
	If Accum[i]>accummost Then accummost=Accum[i]

	If datewas<>data[m*32+date]
		SetColor(0,80,120);SetAlpha(0.2)
		DateSpace=DateSpace+1
		If DateSpace>=DateGap
			SetColor(0,0,0);SetAlpha(1)
			DateSpace=0
			nx=x-(TextWidth(data[m*32+date])/2)
			If nx<4 Then nx=4
			DrawText(data[m*32+date],nx,590+steps)
			steps=(steps+12) Mod 24
			SetAlpha(0.3)
		EndIf
		datewas$=data[m*32+date]
		DrawLine(x,590,x,64)
		SetAlpha(1)
	EndIf

	If None[i]=1 Then None[i]=0
	If x<leftmost Then leftmost=x
	
	If x<1380 And x>-100
		SetColor(InkR[i],InkG[i],InkB[i])
		If WasY[i]>0
			DrawLine(WasX[i],WasY[i],x,y)
		EndIf
		DrawText(data[m*32+count],x-(TextWidth(data[m*32+count])+2),y-12)
		If Flagged[i]=0
			Flagged[i]=1
			ny=y
			Repeat
			fy=ny
			For c=0 To 120
				If Abs(IdentY[c]-ny)<20 Then ny=ny-2
			Next
			Until fy=ny
			IdentY[i]=ny
			DrawText(data[m*32+title],jscrw-TextWidth(data[m*32+title]),ny+4)
			DrawText(PerCount[i],(jscrw-TextWidth(PerCount[i])),ny+16)
			
		EndIf
	EndIf
	WasX[i]=x
	WasY[i]=y
Next

SetColor(0,0,0)
txt$="Total : "+TotalDownloads
DrawText(txt,jscrw-TextWidth(txt),620)

Flip

fin=0
If (KeyDown(KEY_F4) And (KeyDown(KEY_LALT) Or KeyDown(Key_RALT))) Or AppTerminate() Or KeyDown(KEY_ESCAPE) Then fin=1
Until fin=1

img=GrabPixmap(0,0,jscrw,640)
SavePixmapPNG(img,"Daily_Stats_"+CurrentDate()+".png")





scale#=535/accummost

Cls


steps=0
datewas$="2999-12-31"


SetColor(0,0,0)
DrawText("OUYA Download Stats",4,4)
SetColor(100,100,100)
DrawText("DisplayStats app : http://bit.ly/OUYAStats",4,18)
SetColor(0,0,0)

datespace=1000
dategap=1
If ScaleX<0.85 Then dategap=2
If ScaleX<0.6 Then dategap=4
If ScaleX<0.45 Then dategap=7


For n=0 To 120
	Wasy[n]=0
	Flagged[n]=0
	Accum[n]=0
	IdentY[n]=640
Next
For m=dats-1 To 0 Step -1
	x=scrollx+(Int(data[m*32+31])*ScaleX)
	i=Int(data[m*32+30])
	Accum[i]=Accum[i]+Int(data[m*32+count])
	y=585-(Float(Int(Accum[i]))*scale)


	If datewas<>data[m*32+date]		
		SetColor(0,80,120);SetAlpha(0.2)
		DateSpace=DateSpace+1
		If DateSpace>=DateGap
			SetColor(0,0,0);SetAlpha(1)
			DateSpace=0
			nx=x-(TextWidth(data[m*32+date])/2)
			If nx<4 Then nx=4
			DrawText(data[m*32+date],nx,590+steps)
			steps=(steps+12) Mod 24
			SetAlpha(0.3)
		EndIf
		datewas$=data[m*32+date]
		DrawLine(x,590,x,64)
		SetAlpha(1)
	EndIf

	
	If x<1380 And x>-100
		SetColor(InkR[i],InkG[i],InkB[i])
		If WasY[i]>0
			DrawLine(WasX[i],WasY[i],x,y)
		EndIf
		DrawText(data[m*32+count],x-(TextWidth(data[m*32+count])+2),y-12)
		If Flagged[i]=0
			Flagged[i]=1
		EndIf
	EndIf
	WasX[i]=x
	WasY[i]=y
Next

For i=0 To 120
If PerTitle[i]<>""
		SetColor(InkR[i],InkG[i],InkB[i])
			ny=WasY[i]
			Repeat
			fy=ny
			For c=0 To 120
				If Abs(IdentY[c]-ny)<20 Then ny=ny-2
			Next
			Until fy=ny
			IdentY[i]=ny

			DrawText(PerTitle[i],jscrw-TextWidth(PerTitle[i]),ny+4)
			DrawText(PerCount[i],(jscrw-TextWidth(PerCount[i])),ny+16)
EndIf
Next

SetColor(0,0,0)
txt$="Total : "+TotalDownloads
DrawText(txt,jscrw-TextWidth(txt),620)


img=GrabPixmap(0,0,jscrw,640)
SavePixmapPNG(img,"Accumulative_Stats_"+CurrentDate()+".png")
Flip

End